/* Blowfish encrypt/decrypt routines for rtnnpd */
/* Blowfish is Bruce Schneier's block cipher */
/* $Id: blowfish.h,v 1.2 1998/12/01 15:46:16 vasim Exp $ */

#include <sys/types.h>

typedef struct {
  u_int32_t P[18];
  u_int32_t S[4][256];
} bf_subkeys;

/* Use my own broken blowfish algorithm for compatibility with old versions */
extern int brokenfish;

/* Calculate subkeys. Note: 14 <= len <= 56 */
void bf_subkeys_init(bf_subkeys *skeys, unsigned char *key, int len);

/* Encrypt one block (8 bytes) */
u_int64_t bf_encrypt(u_int64_t data, bf_subkeys *skeys);
/* Decrypt one block (8 bytes) */
u_int64_t bf_decrypt(u_int64_t data, bf_subkeys *skeys);

/* Encrypt few blocks. Note: len % 8 == 0 */
u_int64_t bf_encrypt_data(unsigned char *data, int len,
		     u_int64_t init, bf_subkeys *skeys);
/* Decrypt few blocks. Note: len % 8 == 0 */
u_int64_t bf_decrypt_data(unsigned char *data, int len,
		     u_int64_t init, bf_subkeys *skeys);
